:- use_module(library(lists), [permutation/2]). % importls

% Kif az L listabeli szmokbl felptett, Ertek rtk kifejezs.
levelek_ertek_kif(L, Ertek, Kif) :-
	permutation(L, PL), kif_levelek_v(Kif, PL),
	catch(Kif =:= Ertek, _, fail).

% Az alapmveletekkel felptett Kif levllistja L.
kif_levelek_v(Kif, L) :-
	L = [Kif], number(Kif).
kif_levelek_v(Kif, L) :-
	append(L1, L2, L), L1 \= [], L2 \= [],
	kif_levelek_v(K1, L1), kif_levelek_v(K2, L2),
	alap4(K1, K2, Kif).

% alap4(X, Y, K): A K kifejezs X-bl s Y-bl egy alapmvelettel ll el.
alap4(X, Y, X+Y).
alap4(X, Y, X-Y).
alap4(X, Y, X*Y).
alap4(X, Y, X/Y).
