% map(Xs, Pred, Ys): Az Xs lista elemeire a Pred transzformcit
% alkalmazva kapjuk az Ys listt.
map([X|Xs], Pred, [Y|Ys]) :-
        call(Pred, X, Y),
	map(Xs, Pred, Ys).
map([], _, []).

% foldl(+Xs, :Pred, +Y0, -Y): Y0-bl indulva, az Xs elemeire balrl jobbra
% sorra alkalmazva a Pred ltal lert ktargumentum fggvnyt kapjuk Y-t.
foldl([X|Xs], Pred, Y0, Y) :-              
        call(Pred, X, Y0, Y1),
	foldl(Xs, Pred, Y1, Y).            
foldl([], _, Y, Y).                        

% foldr(+Xs, :Pred, +Y0, -Y): Y0-bl indulva, az Xs elemeire jobbrl balra
% sorra alkalmazva a Pred ktargumentum fggvnyt kapjuk Y-t.
foldr([X|Xs], Pred, Y0, Y) :-            
        foldr(Xs, Pred, Y0, Y1),
	call(Pred, X, Y1, Y).           
foldr([], _, Y, Y).                      


% Pldk:

ngyzete(X, Y) :- Y is X*X.

jegyhozz(Alap, Jegy, Szam0, Szam) :- Szam is Szam0*Alap+Jegy.   

proba :-
	map([1,2,3,4], ngyzete, NL),
	write(NL), nl,
	foldl([1,2,3], jegyhozz(10), 0, L),
	write(L), nl,
	foldr([1,2,3], jegyhozz(10), 0, R),
	write(R), nl.

