:- use_module(library(lists)).
:- use_module(library(between)).
:- ensure_loaded('../prolog2_examples/time').

permsA([], Ps) :- !, Ps = [[]].
permsA(Xs, Ps) :-
	findall([Y|Zs], (   member(Y, Xs),
			    delete(Xs, Y, Ys),
			    permsA(Ys, Zss),
			    member(Zs, Zss)
			),
		Ps).

permsB([], Ps) :- !, Ps = [[]].
permsB(Xs, Ps) :-
	findall([Y|Zs], (   select(Y, Xs, Ys),
			    permsB(Ys, Zss),
			    member(Zs, Zss)
			),
		Ps).

permsC([], Ps) :- !, Ps = [[]].
permsC([V|Vs], Ps) :-
	findall(Us,     (   permsC(Vs, Wss),
			    member(Ws, Wss),
			    select(V, Us, Ws)
			),
		Ps).

permsY(Xs, Ps) :-
	findall(P, permutation(Xs, P), Ps).

permsZ(Xs, Ps) :-
	findall(P, perm(Xs, P), Ps).

variant(permsA).
variant(permsB).
variant(permsC).
variant(permsY).
variant(permsZ).


test :-
	member(N-ND, [8-' 8',9-' 9',10-10]),
	nl,
	numlist(1, N, Xs),
	variant(V),
	Goal =..[V,Xs,_],	
	time(V:ND, Goal), 
	fail.
test.

:- test.
